/*
   This is for the parser in Problem 1. That parser should create
   expression tree objects as the result of it parsing.
*/

public class ExpressionTree
{
   private String element;
   private ExpressionTree left;
   private ExpressionTree right;
   int size;

   public ExpressionTree(){ }

   public ExpressionTree(String element)
   {
      this.element = element;
      left = null;
      right = null;
      size = 1;
   }

   public ExpressionTree(String element, ExpressionTree leftSubTree, ExpressionTree rightSubTree)
   {
      this.element = element;
      left = leftSubTree;
      right = rightSubTree;
      size = 1 + leftSubTree.size() + rightSubTree.size();
   }

   public String getElement()
   {
      return element;
   }

   public ExpressionTree getLeft()
   {
      return left;
   }

   public ExpressionTree getRight()
   {
      return right;
   }

   public int size()
   {
      return size;
   }

   public String toString()
   {
      return toStringRecursive(this, "");
   }//toString()


   public String toStringRecursive(ExpressionTree tree, String indentation)
   {
      if ( tree.size() == 1 )
      {
         return (indentation + tree.getElement() + "\n");
      }
      else
      {
         String result = indentation + tree.getElement() + "\n";

         result += toStringRecursive( tree.getLeft(), indentation+" ");

         result += toStringRecursive( tree.getRight(), indentation+" ");

         return result;
      }
   }//toStringRecursive()

}//ExpressionTree
